############################################################
#
# <p>GoogleImageSearch</p>
# <pre>
# {{googleimage ŵ롼}}
# </pre>
#
############################################################
package plugin::googleimage::GoogleImage;
use strict;
use LWP::Simple;
use Encode;
use Encode::JavaScript::UCS;
use JSON::Syck;
#use Data::Dumper;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}

#===========================================================
# ѥ饰ե᥽å
#===========================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $word = shift;
  my $tb = shift;
  my $results = shift;

  if($results eq ""){
    $results = 1;
  }

  my $logo = "<a href=\"http://code.google.com/intl/ja/apis/ajaxsearch/documentation/\">Google AJAX search API</a><br>";

  Encode::from_to($word,"euc-jp","utf8");
  $word = &Util::url_encode($word);

  my $response = get("http://ajax.googleapis.com/ajax/services/search/images?v=1.0&rsz=large&hl=ja&q=$word");
  my $data = JSON::Syck::Load($response);

  my $out = "<div class=\"googleimage\">";
  my $count = 0;

  foreach my $result (@{$data->{responseData}{results}}){
    $count++;
    last if($count > $results);

    my $unescapedUrl = decode('JavaScript-UCS',$result->{unescapedUrl});
    my $tbUrl = decode('JavaScript-UCS',$result->{tbUrl});
    my $originalContextUrl = decode('JavaScript-UCS',$result->{originalContextUrl});
    my $titleNoFormatting = decode('JavaScript-UCS',$result->{titleNoFormatting});
    my $contentNoFormatting = decode('JavaScript-UCS',$result->{contentNoFormatting});

    $out .= "$count.<a href=\"$unescapedUrl\">$titleNoFormatting</a><br>";
    if($tb eq "tb"){
      $out .= "<a href=\"$unescapedUrl\"><img src=\"$tbUrl\" alt=\"$contentNoFormatting\"></a><br>";
    }else{
      $out .= "<img src=\"$unescapedUrl\" alt=\"$contentNoFormatting\"><br>";
    }
    $out .= "<b>RefererUrl:</b> <a href=\"$originalContextUrl\">$originalContextUrl</a><br>";
    $out .= "<b>Content:</b> $contentNoFormatting<br><br>";
  }
  $out .= $logo;
  $out .= "</div>";

  Encode::from_to($out,"utf8","euc-jp");

#$out = Dumper $data;
  return $out;
}

1;

